;**********************************************************************
; Message Authenticator Algorithm          Beycan KAHRAMAN - 040020337
;
; This Assembly code is written to use Message Authenticator Algorithm 
; To use this assembly code you have to write
;
;     unsigned long calculate(unsigned long J,  unsigned long K,
;                             unsigned long *a, unsigned long n);
;
; in the satart of your piece of code. Then send J, K, the mesasge
; array and number of the messages in the array to calculate
; Message Authenticator Value Z.
;**********************************************************************

segment .bss
PAT   resd 1
X     resd 1
Y     resd 1
J     resd 1
K     resd 1
Q     resd 1
X0    resd 1
Y0    resd 1
V0    resd 1
W     resd 1
S     resd 1
T     resd 1
V     resd 1
E     resd 1
G     resd 1

segment .text
global calculate   ; Calculates everyhing and returns Z

A EQU 0x02040801
B EQU 0x00804021
C EQU 0xBFEF7FDF
D EQU 0x7DFEFBFF

;;; GLOBAL CALCULATE FUNCTION ;;;;;;;;;;;;;;;;;;;;
calculate:
    push ebp
    mov  ebp,esp

    mov  eax,[ebp+8]        ;  J -> EAX
    mov  ebx,[ebp+12]       ;  K -> EBX
    push ebx
    push eax
    call prelude            ;  CALL PRELUDE
    add esp,8

    mov  eax,[X0]           ;  get initial values of X, Y and V
    mov  [X],eax
    mov  eax,[Y0]
    mov  [Y],eax
    mov  eax,[V0]
    mov  [V],eax

    mov  ebx,[ebp+16]      ;   ARRAY -> EBX
    mov  edx,[ebp+20]      ;   NUM   -> EDX
calc:
    dec  edx
    mov  [ebp+20],edx      ;   EDX-1 -> NUM
    mov  eax,[ebx]         ;   array[i] -> EAX
    push eax
    call mainloop
    add  esp,4

    mov  ebx,[ebp+16]      ;   ARRAY -> EBX
    add  ebx,4
    mov  [ebp+16],ebx      ;   EBX + 4  -> ARRAY
    mov  edx,[ebp+20]      ;   NUM  -> EDX
    cmp  edx,0
    jnz  calc

    mov  ebx,[S]           ;  lastly call for mainloop with S & T
    push ebx
    call mainloop
    add esp,4

    mov  ebx,[T]
    push ebx
    call mainloop
    add esp,4

    mov eax,[X]            ;  return Z
    xor eax,[Y]

    mov  esp,ebp
    pop  ebp
    ret

;;; MUL1 FUNCTION ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mul1:
    push ebp
    mov  ebp,esp

    mov  eax,[ebp+8]
    mov  ebx,[ebp+12]
    mul  ebx          ;edx:eax

    add  eax,edx
    jnc  mul1s
    inc  eax
mul1s:
    mov  esp,ebp
    pop  ebp
    ret

;;; MUL2 FUNCTION ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mul2:
    push ebp
    mov  ebp,esp

    mov  eax,[ebp+8]
    mov  ebx,[ebp+12]
    mul  ebx          ;edx:eax

    add  edx,edx
    jnc  mul2s
    add  edx,2
mul2s:
    add  eax,edx
    jnc  mul2t
    add  eax,2
mul2t:
    mov  esp,ebp
    pop  ebp
    ret

;;; MUL2A FUNCTION ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mul2a:
    push ebp
    mov  ebp,esp

    mov  eax,[ebp+8]
    mov  ebx,[ebp+12]
    mul  ebx          ;edx:eax

    add  edx,edx
    add  edx,eax
    jnc  mul2as
    add  edx,2
mul2as:
    mov  eax,edx

    mov  esp,ebp
    pop  ebp
    ret

;;; BYT FUNCTION ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
byt:
    push ebp
    mov  ebp,esp

    mov  eax,[ebp+8]
    mov  ebx,[ebp+12]
    mov  [ebp+8],ebx
    mov  [ebp+12],eax ; {X,Y} = {B0,B1,B2,B3,B4,B5,B6,B7}

    mov  edx,0        ;  EDX = P
    mov  ecx,0        ;  i
    mov  ebx,ebp
    mov  eax,0
    add  ebx,15        ;  secilen byte
bytd:
    add  edx,edx      ;  2p
    mov  al,[ebx]

    cmp  al,0
    jne  byt0end
    inc  edx
    mov  al,dl
    jmp  byt255end
byt0end:

    cmp  al,0xFF
    jne  byt255end
    inc  edx
    sub  al,dl
byt255end:
    mov  [ebx],al

    dec  ebx
    inc  ecx
    cmp  ecx,8
    jne  bytd

    mov  [PAT],edx
    mov  eax,[ebp+12]
    mov  [J],eax
    mov  eax,[ebp+8]
    mov  [K],eax

    mov  esp,ebp
    pop  ebp
    ret

;;; PRELUDE FUNCTION ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
prelude:
    push ebp
    mov  ebp,esp
    sub  esp,120

    mov  eax,[ebp+8]
    mov  ebx,[ebp+12]       ;  ARGV --> j,k

    push ebx
    push eax
    call byt                ;  BYT(j,k)  -->  J,K  ,  PAT(j,k)  -->  PAT
    sub  esp,8

    mov  eax,[PAT]
    inc  eax
    mul  eax
    mov  [Q],eax            ;  (PAT+1)*(PAT+1)  -->  Q
;
    mov  eax,[J]
    push eax
    push eax
    call mul1
    add  esp,8
    mov  [esp+8],eax        ;  j12 = mul1(J,J)

    push eax
    push eax
    call mul1
    add  esp,8
    mov  [esp+16],eax       ;  j14 = mul1(J12,J12)

    push eax
    mov  eax,[esp+12]
    push eax
    call mul1
    add  esp,8
    mov  [esp+24],eax       ;  j16 = mul1(J12,J14)

    push eax
    mov  eax,[esp+12]
    push eax
    call mul1
    add  esp,8
    mov  [esp+32],eax       ;  j18 = mul1(J12,J16)
;
    mov  eax,[J]
    push eax
    push eax
    call mul2
    add  esp,8
    mov  [esp+48],eax       ;  j22 = mul2(J,J)

    push eax
    push eax
    call mul2
    add  esp,8
    mov  [esp+56],eax       ;  j24 = mul2(J22,J22)

    push eax
    mov  eax,[esp+52]
    push eax
    call mul2
    add  esp,8
    mov  [esp+64],eax       ;  j26 = mul2(J22,J24)

    push eax
    mov  eax,[esp+52]
    push eax
    call mul2
    add  esp,8
    mov  [esp+72],eax       ;  j28 = mul2(J22,J26)
;
    mov  eax,[esp+16]
    xor  eax,[esp+56]
    mov  [esp+96],eax       ;  h4

    mov  eax,[esp+24]
    xor  eax,[esp+64]
    mov  [esp+104],eax      ;  h6

    mov  eax,[esp+32]
    xor  eax,[esp+72]
    mov  [esp+112],eax      ;  h8
;
    mov  eax,[K]
    push eax
    push eax
    call mul1
    add  esp,8
    mov  [esp+8],eax        ; K12 = mul1(K,K) 

    push eax
    push eax
    call mul1
    add  esp,8
    mov  [esp+16],eax

    push eax
    mov  eax,[K]
    push eax
    call mul1
    add  esp,8
    mov  [esp+20],eax

    push eax
    mov  eax,[esp+12]
    push eax
    call mul1
    add  esp,8
    mov  [esp+28],eax

    push eax
    mov  eax,[esp+12]
    push eax
    call mul1
    add  esp,8
    mov  [esp+36],eax
;
    mov  eax,[K]
    push eax
    push eax
    call mul2
    add  esp,8
    mov  [esp+48],eax

    push eax
    push eax
    call mul2
    add  esp,8
    mov  [esp+56],eax

    push eax
    mov  eax,[K]
    push eax
    call mul2
    add  esp,8
    mov  [esp+60],eax

    push eax
    mov  eax,[esp+52]
    push eax
    call mul2
    add  esp,8
    mov  [esp+68],eax

    push eax
    mov  eax,[esp+52]
    push eax
    call mul2
    add  esp,8
    mov  [esp+76],eax
;
    mov  eax,[esp+20]
    xor  eax,[esp+60]
    mov  [esp+80],eax      ;  H0

    mov  eax,[Q]
    push eax
    mov  eax,[esp+84]
    push eax
    call mul2
    add  esp,8
    mov  [esp+100],eax     ;  H5

    mov  eax,[esp+28]
    xor  eax,[esp+68]
    mov  [esp+108],eax     ;  H5

    mov  eax,[esp+36]
    xor  eax,[esp+76]
    mov  [esp+116],eax     ;  H5
;
    mov  eax,[esp+100]
    push eax
    mov  eax,[esp+100]
    push eax
    call byt
    add  esp,8
    mov  eax,[J]
    mov  [X0],eax
    mov  eax,[K]
    mov  [Y0],eax          ;  {X0,Y0} = BYT(H4,H5)

    mov  eax,[esp+108]
    push eax
    mov  eax,[esp+108]
    push eax
    call byt
    add  esp,8
    mov  eax,[J]
    mov  [V0],eax
    mov  eax,[K]
    mov  [W],eax          ;  {V0, W} = BYT(H6,H7)

    mov  eax,[esp+116]
    push eax
    mov  eax,[esp+116]
    push eax
    call byt
    add  esp,8
    mov  eax,[J]
    mov  [S],eax
    mov  eax,[K]
    mov  [T],eax          ;  {S , T} = BYT(H8,H9)

    mov  esp,ebp
    pop  ebp
    ret

;;; MAINLOOP FUNCTION ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mainloop:
    push ebp
    mov  ebp,esp

    mov  ebx,[ebp+8]      ;  M --> EBX

    mov  eax,[V]
    rol  eax,1
    mov  [V],eax          ;  CYC(V) --> V

    xor  eax,[W]
    mov  [E],eax          ;  XOR(V,X) --> E

    xor  ebx,[X]
    mov  [X],ebx          ;  XOR(M,X) --> X

    mov  ebx,[ebp+8]
    xor  ebx,[Y]
    mov  [Y],ebx          ;  XOR(M,Y) --> Y

    add  eax,[Y]          ; (ecx:F   edx:G)
    mov  ecx,eax          ;  ADD(E,Y) --> F

    mov  eax,[X]
    add  eax,[E]
    mov  edx,eax          ;  ADD(E,X) --> G

    or   ecx,A            ;  OR(F,A) --> F

    or   edx,B            ;  OR(G,B) --> G

    and  ecx,C            ;  AND(F,C) --> F

    and  edx,D            ;  AND(G,D) --> G
    mov  [G],edx

    push ecx
    mov  eax,[X]
    push eax
    call mul1
    add esp,8
    mov [X],eax           ;  MUL1(X,F) --> X

    mov  edx,[G]
    push edx
    mov  eax,[Y]
    push eax
    call mul2a
    add esp,8
    mov [Y],eax           ;  MUL2A(Y,G) --> Y

    mov  esp,ebp
    pop  ebp
    ret
